<?php
namespace FiloBlu\Flow\Model\Channel\In;

class Price extends AbstractModel {

    public function __construct() {
        $this->init('price');
    }

    public function insertData($data) {

        $flow = $this->getFile()->getData('flow');
        $model =  \Magento\Framework\App\ObjectManager::getInstance()->create('FiloBlu\Flow\Model' . "\\" . $flow);

        if (!$model)
            return false;

        $model->setData('meta_file',$this->getFile()->getId());
        $codice_articolo = $data['sku'];
        $model->setData("sku", $codice_articolo);

        foreach($data as $field => $value){
            if(floatval($value) <= 0 ) continue;
            $fieldMap = $this->map->get($field);
            if(!isset($fieldMap["skip"])) {
                $to_field = $fieldMap["to"];
                //devo inserire una riga per ogni website/prezzo
                if ($fieldMap['type'] == 'price'){

                    if(is_array($fieldMap['website'])){
                        $websites = $fieldMap['website'];

                        foreach($websites as $website){
                            $currency = $fieldMap['currency'];
                            $model->setId(null);
                            $model->setData($to_field, floatval($value));
                            $model->setData("paese", $website);
                            $model->setData("valuta", $currency);
                            $model->setData("meta_processed", 0);
                            $model->setData("meta_insert_time", date("Y-m-d H:i:s", time()));
//                            $model->setData("tipo_prezzo", FiloBlu_Flow_Helper_Price::TYPE_PIENO);
                            $model->save();
                        }
                    }
                    else {
                        $currency = $fieldMap['currency'];
                        $website = $fieldMap['website'];
                        $model->setId(null);
                        $model->setData($to_field, floatval($value));
                        $model->setData("paese", $website);
                        $model->setData("valuta", $currency);
                        $model->setData("meta_processed", 0);
                        $model->setData("meta_insert_time", date("Y-m-d H:i:s", time()));
//                        $model->setData("tipo_prezzo", FiloBlu_Flow_Helper_Price::TYPE_PIENO);
                        $model->save();
                    }
                }
            }
        }
    }

}